    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * SymbolicXYItemLabelGenerator.java
    029     * ---------------------------------
    030     * (C) Copyright 2001-2007, by Anthony Boulestreau and Contributors.
    031     *
    032     * Original Author:  Anthony Boulestreau;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * Changes
    036     * -------
    037     * 29-Mar-2002 : Version 1, contributed by Anthony Boulestreau (DG);
    038     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    039     * 23-Mar-2003 : Implemented Serializable (DG);
    040     * 13-Aug-2003 : Implemented Cloneable (DG);
    041     * 17-Nov-2003 : Implemented PublicCloneable (DG);
    042     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator (DG);
    043     * 19-Jan-2005 : Now accesses primitives only from dataset (DG);
    044     * 20-Apr-2005 : Renamed XYLabelGenerator --> XYItemLabelGenerator (DG);
    045     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    046     *
    047     */
    048
    049    package org.jfree.chart.labels;
    050
    051    import java.io.Serializable;
    052
    053    import org.jfree.data.time.RegularTimePeriod;
    054    import org.jfree.data.time.TimeSeriesCollection;
    055    import org.jfree.data.xy.XYDataset;
    056    import org.jfree.data.xy.XisSymbolic;
    057    import org.jfree.data.xy.YisSymbolic;
    058    import org.jfree.util.PublicCloneable;
    059
    060    /**
    061     * A standard item label generator for plots that use data from an
    062     * {@link XYDataset}.
    063     */
    064    public class SymbolicXYItemLabelGenerator implements XYItemLabelGenerator,
    065                                                         XYToolTipGenerator,
    066                                                         Cloneable,
    067                                                         PublicCloneable,
    068                                                         Serializable {
    069
    070        /** For serialization. */
    071        private static final long serialVersionUID = 3963400354475494395L;
    072
    073        /**
    074         * Generates a tool tip text item for a particular item within a series.
    075         *
    076         * @param data  the dataset.
    077         * @param series  the series number (zero-based index).
    078         * @param item  the item number (zero-based index).
    079         *
    080         * @return The tool tip text (possibly <code>null</code>).
    081         */
    082        public String generateToolTip(XYDataset data, int series, int item) {
    083
    084            String xStr, yStr;
    085            if (data instanceof YisSymbolic) {
    086                yStr = ((YisSymbolic) data).getYSymbolicValue(series, item);
    087            }
    088            else {
    089                double y = data.getYValue(series, item);
    090                yStr = Double.toString(round(y, 2));
    091            }
    092            if (data instanceof XisSymbolic) {
    093                xStr = ((XisSymbolic) data).getXSymbolicValue(series, item);
    094            }
    095            else if (data instanceof TimeSeriesCollection) {
    096                RegularTimePeriod p
    097                    = ((TimeSeriesCollection) data).getSeries(series)
    098                        .getTimePeriod(item);
    099                xStr = p.toString();
    100            }
    101            else {
    102                double x = data.getXValue(series, item);
    103                xStr = Double.toString(round(x, 2));
    104            }
    105            return "X: " + xStr + ", Y: " + yStr;
    106        }
    107
    108        /**
    109         * Generates a label for the specified item. The label is typically a
    110         * formatted version of the data value, but any text can be used.
    111         *
    112         * @param dataset  the dataset (<code>null</code> not permitted).
    113         * @param series  the series index (zero-based).
    114         * @param category  the category index (zero-based).
    115         *
    116         * @return The label (possibly <code>null</code>).
    117         */
    118        public String generateLabel(XYDataset dataset, int series, int category) {
    119            return null;  //TODO: implement this method properly
    120        }
    121
    122        /**
    123        * Round a double value.
    124        *
    125        * @param value  the value.
    126        * @param nb  the exponent.
    127        *
    128        * @return The rounded value.
    129        */
    130        private static double round(double value, int nb) {
    131            if (nb <= 0) {
    132                return Math.floor(value + 0.5d);
    133            }
    134            double p = Math.pow(10, nb);
    135            double tempval = Math.floor(value * p + 0.5d);
    136            return tempval / p;
    137        }
    138
    139        /**
    140         * Returns an independent copy of the generator.
    141         *
    142         * @return A clone.
    143         *
    144         * @throws CloneNotSupportedException if cloning is not supported.
    145         */
    146        public Object clone() throws CloneNotSupportedException {
    147            return super.clone();
    148        }
    149
    150        /**
    151         * Tests if this object is equal to another.
    152         *
    153         * @param obj  the other object.
    154         *
    155         * @return A boolean.
    156         */
    157        public boolean equals(Object obj) {
    158            if (obj == this) {
    159                return true;
    160            }
    161            if (obj instanceof SymbolicXYItemLabelGenerator) {
    162                return true;
    163            }
    164            return false;
    165        }
    166
    167    }